/*******************************************************************************
 * Copyright (C) Altimetrik 2018. All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Altimetrik. You shall not disclose such Confidential Information
 * and shall use it only in accordance with the terms and conditions
 * entered into with Altimetrik.
 ******************************************************************************/
package com.altimetrik.playground.innovation.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import com.altimetrik.playground.innovation.constants.ActionTypeEnum;
import com.altimetrik.playground.innovation.constants.RoleTypeEnum;

/**
 * Custom annotation which is used to tag a web service to specify the roles
 * information which is used for validation by the RolesInterceptor.
 * 
 * @author skondapalli.
 */
@Retention(RetentionPolicy.RUNTIME)
@Target({ ElementType.METHOD, ElementType.TYPE })
public @interface RolesAllowed {

	RoleTypeEnum[] roles();

	ActionTypeEnum action();

	String description() default "";

}
