/*******************************************************************************
 * Copyright (C) Altimetrik 2018. All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Altimetrik. You shall not disclose such Confidential Information
 * and shall use it only in accordance with the terms and conditions
 * entered into with Altimetrik.
 ******************************************************************************/
package com.altimetrik.playground.innovation.bean;

import java.io.Serializable;
import java.util.Date;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

import com.altimetrik.playground.innovation.constants.ArtifactTypeEnum;

import lombok.Data;

@Data
public class PgIdeaArtifact implements Serializable {

	private static final long serialVersionUID = -8931921342171547040L;
	private String id;
	@NotBlank
	private String linkName;
	@NotNull
	private ArtifactTypeEnum artifactType;
	@NotBlank
	private String linkUrl;
	private String fileName;
	private String createdBy;
	private Date createdOn;

	public PgIdeaArtifact(String id, String linkName, ArtifactTypeEnum artifactType, String linkUrl, String fileName, String createdBy, Date createdOn) {
		super();
		this.id = id;
		this.linkName = linkName;
		this.artifactType = artifactType;
		this.linkUrl = linkUrl;
		this.fileName = fileName;
		this.createdBy = createdBy;
		this.createdOn = createdOn;
	}

}
