/*******************************************************************************
 * Copyright (C) Altimetrik 2018. All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Altimetrik. You shall not disclose such Confidential Information
 * and shall use it only in accordance with the terms and conditions
 * entered into with Altimetrik.
 ******************************************************************************/
package com.altimetrik.playground.innovation.constants;

import java.util.HashSet;
import java.util.Set;

import lombok.extern.slf4j.Slf4j;

@Slf4j
public enum IdeaStatusEnum {

	NOT_SUBMITTED("NOT_SUBMITTED"), SUBMITTED("SUBMITTED"), DRAFT("DRAFT"), PUBLISH("PUBLISH"), L0_REVIEW("L0_REVIEW"), L1_REVIEW("L1_REVIEW"), L2_REVIEW("L2_REVIEW"), REWORK(
			"REWORK"), APPROVED("APPROVED"), REJECTED("REJECTED");

	private final String message;

	IdeaStatusEnum(final String argMessage) {
		message = argMessage;
	}

	public final String getMessage() {
		return message;
	}

	public Set<IdeaStatusEnum> getAllowedIdeaStatusTransitions() {
		final Set<IdeaStatusEnum> allowedIdeaStatusTransitions = new HashSet<IdeaStatusEnum>();
		switch (this) {
		case DRAFT:
			allowedIdeaStatusTransitions.add(IdeaStatusEnum.DRAFT);
			allowedIdeaStatusTransitions.add(IdeaStatusEnum.PUBLISH);
			break;
		case PUBLISH:
			allowedIdeaStatusTransitions.add(IdeaStatusEnum.PUBLISH);
			allowedIdeaStatusTransitions.add(IdeaStatusEnum.L0_REVIEW);
			break;
		case L0_REVIEW:
			allowedIdeaStatusTransitions.add(IdeaStatusEnum.L0_REVIEW);
			allowedIdeaStatusTransitions.add(IdeaStatusEnum.REWORK);
			allowedIdeaStatusTransitions.add(IdeaStatusEnum.REJECTED);
			break;
		case REWORK:
			allowedIdeaStatusTransitions.add(IdeaStatusEnum.REWORK);
			allowedIdeaStatusTransitions.add(IdeaStatusEnum.L0_REVIEW);
			allowedIdeaStatusTransitions.add(IdeaStatusEnum.L1_REVIEW);
			allowedIdeaStatusTransitions.add(IdeaStatusEnum.L2_REVIEW);
			break;
		case REJECTED:
			allowedIdeaStatusTransitions.add(IdeaStatusEnum.REJECTED);
			break;
		default:
			log.info("Status transition not configured", this);
			break;
		}
		return allowedIdeaStatusTransitions;
	}

}
