/*******************************************************************************
 * Copyright (C) Altimetrik 2018. All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Altimetrik. You shall not disclose such Confidential Information
 * and shall use it only in accordance with the terms and conditions
 * entered into with Altimetrik.
 ******************************************************************************/
package com.altimetrik.playground.innovation.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import com.altimetrik.playground.innovation.bean.PgIdeaCategoryListResponse;
import com.altimetrik.playground.innovation.bean.PgIdeaCategoryRequest;
import com.altimetrik.playground.innovation.bean.PgIdeaCategoryResponse;
import com.altimetrik.playground.innovation.exception.InnovationServiceException;
import com.altimetrik.playground.innovation.service.PgIdeaCategoryService;

@RestController
public class PgIdeaCategoryContoller extends BaseController {

	@Autowired
	private PgIdeaCategoryService pgIdeaCategoryService;

	@GetMapping(value = "/v1/categories")
	public ResponseEntity<PgIdeaCategoryListResponse> getCategories() throws InnovationServiceException {
		return ResponseEntity.ok(pgIdeaCategoryService.findAllCategories());
	}

	@GetMapping(value = "/v1/categories/{id}")
	public ResponseEntity<PgIdeaCategoryResponse> getCategoriesById(@PathVariable("id") final String id) throws InnovationServiceException {
		return ResponseEntity.ok(pgIdeaCategoryService.findByCategoryId(id));
	}

	@PostMapping(value = "/v1/categories")
	public ResponseEntity<PgIdeaCategoryResponse> createCategories(@RequestBody PgIdeaCategoryRequest req) throws InnovationServiceException {
		return ResponseEntity.ok(pgIdeaCategoryService.createCategory(req));
	}

}
