/**
 * Copyright (C) Altimetrik 2018. All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Altimetrik. You shall not disclose such Confidential Information
 * and shall use it only in accordance with the terms and conditions
 * entered into with Altimetrik.
 */
package com.altimetrik.playground.innovation.entity;

import java.util.List;

import org.springframework.data.mongodb.core.index.Indexed;
import org.springframework.data.mongodb.core.mapping.Document;

import com.altimetrik.playground.innovation.constants.IdeaStatusEnum;
import com.altimetrik.playground.innovation.constants.IdeaTypeEnum;

import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * @author Tushar Das
 *
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Document(collection = "pgIdea")
public class PgIdeaEntity extends BaseEntity {

	private static final long serialVersionUID = -3397851459471988688L;

	@Indexed(unique = true)
	private String title;

	private String description;

	private String businessRelevance;

	private String ideaCategoryId;

	private Boolean competenceCenter;

	private IdeaTypeEnum ideaType;

	private IdeaStatusEnum status;

	private Boolean published;

	private Boolean locked;

	private String businessDomain;

	private String technologyDomain;

	private String techStack;

	private String novelty;

	private String claims;

	private String completeness;

	private String l0ReviewerId;

	private List<PgIdeaArtifactEntity> artifacts;

	private List<PgReviewStatusEntity> reviews;

	private List<PgTeamEntity> team;

	private Boolean disclosed = false;

	private String accessLevel;

	public PgIdeaEntity() {
		super();
	}
}
