/*******************************************************************************
 * Copyright (C) Altimetrik 2018. All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Altimetrik. You shall not disclose such Confidential Information
 * and shall use it only in accordance with the terms and conditions
 * entered into with Altimetrik.
 ******************************************************************************/
package com.altimetrik.playground.innovation.exception;

import java.util.Locale;

public class InnovationServiceException extends PgApplicationException {

	private static final long serialVersionUID = 473448373330820013L;

	@Override
	public String getLocalizedMessage(String errorCode, Locale locale, Object... args) {
		if (args != null && args.length > 0)
			return (String) args[0];
		else
			return null;
	}

	/**
	 * single argument constructor.
	 * @param errorCode - this argument receives error code instead of message.
	 * @param errorArgs - the arguments to be used to replace values within the
	 *            message.
	 */
	public InnovationServiceException(String errorCode, Object... errorArgs) {
		this(errorCode, null, errorArgs);
	}

	/**
	 * Preferred constructor to be used to wrap the underlying exception within this
	 * exception object.
	 * @param errorCode - object encapsulating the error details(error code and
	 *            message) with the predefined errorCode and message template.
	 * @param cause - the underlying cause of the exception
	 * @param errorArgs - the arguments to be used to replace values within the
	 *            message.
	 */
	public InnovationServiceException(String errorCode, Throwable cause, Object... errorArgs) {
		super(errorCode, cause, errorArgs);
	}
}
