/*******************************************************************************
 * Copyright (C) Altimetrik 2018. All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Altimetrik. You shall not disclose such Confidential Information
 * and shall use it only in accordance with the terms and conditions
 * entered into with Altimetrik.
 ******************************************************************************/
package com.altimetrik.playground.innovation.service;

import org.springframework.stereotype.Service;

import com.altimetrik.playground.innovation.bean.BaseResponse;
import com.altimetrik.playground.innovation.bean.PgIdeaArtifact;
import com.altimetrik.playground.innovation.bean.PgIdeaArtifactListResponse;
import com.altimetrik.playground.innovation.bean.PgIdeaRequest;
import com.altimetrik.playground.innovation.bean.PgIdeaResponse;
import com.altimetrik.playground.innovation.bean.PgIdeaSearchRequest;
import com.altimetrik.playground.innovation.bean.PgIdeaSearchResponse;
import com.altimetrik.playground.innovation.bean.PgIdeaTeamInviteRequest;
import com.altimetrik.playground.innovation.bean.PgIdeaTeamListResponse;
import com.altimetrik.playground.innovation.exception.PgApplicationException;

@Service
public interface PgIdeaService {

	PgIdeaSearchResponse getAllIdeas(PgIdeaSearchRequest req) throws PgApplicationException;

	PgIdeaResponse getIdea(String req) throws PgApplicationException;

	PgIdeaArtifactListResponse addArtifact(String ideaId, PgIdeaArtifact req) throws PgApplicationException;

	PgIdeaArtifactListResponse getArtifact(String ideaId) throws PgApplicationException;

	PgIdeaResponse createIdea(PgIdeaRequest pgIdeaRequest) throws PgApplicationException;

	PgIdeaResponse updateIdea(String ideaId, PgIdeaRequest pgIdeaRequest) throws PgApplicationException;

	PgIdeaTeamListResponse getTeamList(String ideaId) throws PgApplicationException;

	PgIdeaTeamListResponse listTeamRequests(String ideaId) throws PgApplicationException;

	BaseResponse joinRequest(String ideaId) throws PgApplicationException;

	BaseResponse acceptJoinRequests(String ideaId, String requestId) throws PgApplicationException;

	BaseResponse rejectJoinRequests(String ideaId, String requestId) throws PgApplicationException;

	BaseResponse inviteTeamRequests(String ideaId, PgIdeaTeamInviteRequest request) throws PgApplicationException;

	BaseResponse rejectTeamRequest(String ideaId, String requestId) throws PgApplicationException;

	BaseResponse acceptTeamRequest(String ideaId, String requestId) throws PgApplicationException;
}
